"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var fs = require("fs-extra");
var path = require("path");
var util = require("util");
var diff = require('json-diff').diff;
var colorize = require('json-diff/lib/colorize').colorize;
function Run(args) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        var _a, from, to, fromTypes, toTypes, fileName, outputStream, write, promises;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, Promise.all([
                        fs.readFile(args.from),
                        fs.readFile(args.to)
                    ])];
                case 1:
                    _a = (_b.sent()).map(function (b) { return JSON.parse(b.toString()); }), from = _a[0], to = _a[1];
                    fromTypes = indexById(from.contentTypes);
                    toTypes = indexById(to.contentTypes);
                    fileName = new Date().toISOString().replace(/[^\d]/g, '').substring(0, 14) + "_generated_from_diff.ts";
                    outputStream = fs.createWriteStream(path.join(args.outDir, fileName));
                    write = asyncWrite(outputStream);
                    return [4 /*yield*/, write("import Migration from 'contentful-migration-cli'\n\n// Generated by contentful-schema-diff\n// from " + args.from + "\n// to   " + args.to + "\nexport = function (migration: Migration) {\n")];
                case 2:
                    _b.sent();
                    promises = Object.keys(toTypes).map(function (id) { return __awaiter(_this, void 0, void 0, function () {
                        var chunk;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!fromTypes[id]) return [3 /*break*/, 2];
                                    return [4 /*yield*/, writeModify(fromTypes[id], toTypes[id])];
                                case 1:
                                    chunk = _a.sent();
                                    return [3 /*break*/, 4];
                                case 2: return [4 /*yield*/, writeCreate(toTypes[id])];
                                case 3:
                                    chunk = _a.sent();
                                    _a.label = 4;
                                case 4:
                                    if (!(chunk && chunk.length > 0)) return [3 /*break*/, 6];
                                    return [4 /*yield*/, write(chunk)];
                                case 5:
                                    _a.sent();
                                    _a.label = 6;
                                case 6: return [2 /*return*/];
                            }
                        });
                    }); });
                    promises.push.apply(promises, Object.keys(fromTypes).map(function (id) { return __awaiter(_this, void 0, void 0, function () {
                        var chunk;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (toTypes[id]) {
                                        // handled above in 'writeModify'
                                        return [2 /*return*/];
                                    }
                                    return [4 /*yield*/, writeDelete(id)];
                                case 1:
                                    chunk = _a.sent();
                                    return [4 /*yield*/, write(chunk)];
                                case 2:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); }));
                    return [4 /*yield*/, Promise.all(promises)];
                case 3:
                    _b.sent();
                    return [4 /*yield*/, write("\n}\n")];
                case 4:
                    _b.sent();
                    outputStream.close();
                    return [2 /*return*/];
            }
        });
    });
}
exports["default"] = Run;
function indexById(types) {
    var ret = {};
    types.forEach(function (type) {
        ret[type.sys.id] = type;
    });
    return ret;
}
function asyncWrite(stream) {
    var draining = true;
    function doWrite(chunk) {
        return new Promise(function (resolve, reject) {
            if (draining) {
                draining = stream.write(chunk, function (err) {
                    if (err) {
                        reject(err);
                    }
                    else {
                        resolve();
                    }
                });
            }
            else {
                stream.on('drain', function () {
                    // await recursive
                    doWrite(chunk)
                        .then(resolve)["catch"](reject);
                });
            }
        });
    }
    return doWrite;
}
function writeDelete(id) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, "\n  migration.deleteContentType('" + id + "')\n"];
        });
    });
}
function writeModify(from, to) {
    return __awaiter(this, void 0, void 0, function () {
        var difference, v, typeDef, str;
        return __generator(this, function (_a) {
            difference = diff(from.fields, to.fields);
            if (!difference || difference.length == 0) {
                return [2 /*return*/];
            }
            v = camelCase(from.sys.id);
            typeDef = Object.assign({}, to);
            delete (typeDef.fields);
            delete (typeDef.sys);
            str = "\n  var " + v + " = migration.editContentType('" + from.sys.id + "', " + dump(typeDef) + ")\n";
            str += "\n  /* TODO: automatically generate edits from this diff\n" + colorize(difference, { color: false }) + " */\n  ";
            return [2 /*return*/, str];
        });
    });
}
function writeCreate(newType) {
    return __awaiter(this, void 0, void 0, function () {
        var v, typeDef, str;
        return __generator(this, function (_a) {
            v = camelCase(newType.sys.id);
            typeDef = Object.assign({}, newType);
            delete (typeDef.fields);
            delete (typeDef.sys);
            str = "\n  var " + v + " = migration.createContentType('" + newType.sys.id + "', " + dump(typeDef) + ")\n";
            newType.fields.forEach(function (field) {
                var fieldDef = Object.assign({}, field);
                delete (fieldDef.id);
                str += "\n  " + v + ".createField('" + field.id + "', " + dump(fieldDef) + ")\n";
            });
            return [2 /*return*/, str];
        });
    });
}
function dump(obj) {
    return util.inspect(obj, {
        depth: null,
        maxArrayLength: null,
        breakLength: 0
    });
}
function camelCase(input) {
    return input.toLowerCase().replace(/-(.)/g, function (match, group1) {
        return group1.toUpperCase();
    });
}
